Subject: Re: 27.0.50; harfbuzz branch fails to compile

From: Khaled Hosny <[email-masked]>
Date: Sat, 15 Dec 2018 00:52:53 +0200

On Fri, Dec 14, 2018 at 03:27:37PM -0500, Eli Zaretskii wrote:
> 
> The compilation fails with this error:
> 
>     CC       ftfont.o
>   ftfont.c: In function ‘ftfont_shape_by_hb’:
>   ftfont.c:2866:3: warning: implicit declaration of function ‘hb_buffer_set_cluster_level’ [-Wimplicit-function-declaration]
>      hb_buffer_set_cluster_level (hb_buffer, HB_BUFFER_CLUSTER_LEVEL_MONOTONE_CHARACTERS);
>      ^
>   ftfont.c:2866:43: error: ‘HB_BUFFER_CLUSTER_LEVEL_MONOTONE_CHARACTERS’ undeclared (first use in this function)
>      hb_buffer_set_cluster_level (hb_buffer, HB_BUFFER_CLUSTER_LEVEL_MONOTONE_CHARACTERS);
> 					     ^
>   ftfont.c:2866:43: note: each undeclared identifier is reported only once for each function it appears in
>   make[1]: *** [ftfont.o] Error 1
> 
> The version of Harfbuzz I have on this machine is 0.9.27.  If this too old?  If so, what minimum version do I need to successfully build the branch?

Seems so. You can add configure.ac checks for hb_buffer_set_cluster_level
and use it conditionally, or require a newer HarfBuzz version. I prefer
the later, since the behaviour of cluster level 1 is assumed elsewhere
in the code (I don’t recall what exactly).

Regards,
Khaled